{    var   : }
{ N, LIA, M, MAX, EPS }
Unit MLC3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLC33_p, MLC35_p, MLC36_p, MLC37_p, MLC38_p, MLC39_p, MLC3A_p,
MLC3B_p, MLC3L_p, MLC3V_p;

procedure MLC3R(LIA :Integer; M :Integer; N :Integer;
                var IA :Array of Integer; var KV :Array of Integer;
                var X :Array of Integer; var C :Array of Integer;
                var Z :Integer; MAX :Integer;
                var B :Array of Integer; var MR :Array of Integer;
                EPS :Real; var IERR :Integer);

implementation

procedure MLC3R(LIA :Integer; M :Integer; N :Integer;
                var IA :Array of Integer; var KV :Array of Integer;
                var X :Array of Integer; var C :Array of Integer;
                var Z :Integer; MAX :Integer;
                var B :Array of Integer; var MR :Array of Integer;
                EPS :Real; var IERR :Integer);
var
I,I1,I2,IAV,IJA,IK,IPJ,IPS,IPV,ISL,ISL0,ISUM,ITER,IV,J,J1,J2,JT,K,K1,
   LJ,N1,NAV,NM,S :Integer;
R,RLD,XV :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150;
begin
{      (OCHOBHA(BEYA)OPOPAMMA) }
NM := N + M;
IERR := 0;
ISL := 1;
ISL0 := 1 + N;
IAV := 1 + N*2;
IJA := 2 + N*3;
IPV := 3 + N*4;
IPS := IPV + N;
K := N;
if ( M >  N ) 
 then K := M;
IPJ := IPS + K + 1;
N1 := N + 1;
MLC3B(B,N);
ITER := 0;
JT := 0;
for J:=1 to N do
 begin
  if ( C[J-1] <  0 ) 
   then goto _20;
_10:
 end;
goto _30;
{  EPEXO K BOCTBEHHO OYCTMO AAE }
_20:
MLC39(IA,LIA,KV,M,B,N,X,NM,C,MAX,Z,MR[ISL-1],MR[IPJ-1],
     MR[IPS-1]);
{   HAAO TEPA }
_30:
ITER := ITER + 1;
{   EPECKA POBOE CTPOK }
{    MATP B B PAO BEKTOP }
MLC3V(MR[IPV-1],N,X,NM,B,IA,LIA,IV,KV,M,MR[IAV-1],MR[IJA-1],
     IK);
if ( IK =  1 ) 
 then goto _150;
{   OPMPOBAHE MHOECTBA HOMEPOB }
{   OTPATEHX KOMOHEHT POBOE CTPOK }
MLC37(MR[IPV-1],N,MR[ISL-1],K);
if ( K =  0 ) 
 then goto _140;
{      18-METKA:PEEH HET }
if ( K =  1 ) 
 then goto _60;
for I:=1 to K do
 begin
  I1 := ISL + I - 1;
  I2 := ISL0 + I - 1;
  MR[I2-1] := MR[I1-1];
_40:
 end;
{   OPMPOBAHE MHOECTBA HOMEPOB, }
{   COOTBETCTBYX MHMAHOMY }
{   HAEH C(J) CPE TEX J, }
{   KOTOPE EPECEH B SEL }
MLC38(C,N,MR[ISL-1],K,K1);
if ( K1 =  1 ) 
 then goto _60;
{   OCK EKCKOPAECK MHMAHOO }
{   CTOA MATP -B CPE TEX, }
{   HOMEPA KOTOPX EPECEH B SEL }
MLC3A(B,N,MR[ISL-1],K1,S);
for I:=2 to N1 do
 begin
  I1 := IPS + I - 1;
  MR[I1-1] := -B[(I-2)+(S-1)*N];
_50:
 end;
MR[IPS-1] := C[S-1];
{   BCEHE LAMBEA }
MLC3L(B,N,MR[IPS-1],N1,MR[IPJ-1],MR[ISL0-1],RLD,C,
     K,S,MR[IPV-1]);
goto _70;
_60:
S := MR[ISL-1];
I1 := IPV + S - 1;
RLD := -MR[I1-1];
_70:
{   OPMPOBAHE KOEHTOB }
{   OTCEEH OMOP }
for J:=1 to N do
 begin
  J1 := IPV + J - 1;
  R := MR[J1-1]/RLD;
  J1 := J;
  MLC36(R,MR[J1-1],EPS);
_80:
 end;
{   EPECET HEHO OPM,PEEH  OEHOK }
XV := X[IV-1]/RLD;
MLC36(XV,MAX,EPS);
if ( C[S-1] =  0 ) 
 then goto _100;
Z := Z + MAX*C[S-1];
for J:=1 to N do
 begin
  if ( J =  S ) 
   then goto _90;
  J1 := J;
  C[J-1] := C[J-1] + MR[J1-1]*C[S-1];
_90:
 end;
_100:
for I:=1 to N do
 begin
  X[I-1] := X[I-1] - MAX*B[(I-1)+(S-1)*N];
_110:
 end;
for I:=1 to M do
 begin
  I1 := N + I;
  MLC33(IA,LIA,KV,M,I,MR[IAV-1],MR[IJA-1],NAV,N);
  ISUM := 0;
  for J:=1 to NAV do
   begin
    J1 := IJA + J - 1;
    LJ := MR[J1-1];
    J2 := IAV + J - 1;
    ISUM := ISUM + MR[J2-1]*B[(LJ-1)+(S-1)*N];
_120:
   end;
  X[I1-1] := X[I1-1] + MAX*ISUM;
_130:
 end;
MLC35(B,N,MR,S);
goto _30;
_140:
IERR := 65;
_150:
end;

end.
