Unit MLC3V_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLC33_p;

procedure MLC3V(var PV :Array of Integer; N :Integer;
                var X :Array of Integer; NM :Integer;
                var B :Array of Integer; var UA :Array of Integer;
                DUA :Integer; var IV :Integer;
                var V :Array of Integer; M :Integer;
                var AV :Array of Integer; var JAV :Array of Integer;
                var IK :Integer);

implementation

procedure MLC3V(var PV :Array of Integer; N :Integer;
                var X :Array of Integer; NM :Integer;
                var B :Array of Integer; var UA :Array of Integer;
                DUA :Integer; var IV :Integer;
                var V :Array of Integer; M :Integer;
                var AV :Array of Integer; var JAV :Array of Integer;
                var IK :Integer);
var
I,ISUM,IV1,J,LI,NAV :Integer;
label
_10,_20,_30,_40,_50,_60,_70,_80;
begin
{   OCK EPBO OTPATEHO KOMOHEHT }
{   BEKTOPA X }
IK := 0;
for I:=1 to NM do
 begin
  if ( X[I-1] <  0 ) 
   then goto _20;
_10:
 end;
IK := 1;
goto _80;
_20:
IV := I;
if ( IV >  N ) 
 then goto _40;
for J:=1 to N do
 begin
  PV[J-1] := -B[(IV-1)+(J-1)*N];
_30:
 end;
goto _70;
_40:
IV1 := IV - N;
{   EPECKA HOPMA O POBOE }
{   CTPOKE B MACCB AV,JAV }
MLC33(UA,DUA,V,M,IV1,AV,JAV,NAV,N);
for J:=1 to N do
 begin
  ISUM := 0;
  for I:=1 to NAV do
   begin
    LI := JAV[I-1];
    ISUM := ISUM + AV[I-1]*B[(LI-1)+(J-1)*N];
_50:
   end;
  PV[J-1] := ISUM;
_60:
 end;
_70:
_80:
end;

end.
